extends KinematicBody2D


export var CLOSE_ENOUGH = 20
export var WALK_SPEED = 200
export (NodePath) var NAV_NODE
export (NodePath) var PLAYER_NODE
export (NodePath) var PATROL_NODE

enum State {PATROL = 1, CHASE = 2, DONE = 0}

var navigation2d : Navigation2D
var player : Node2D
var patrol
var next_node
var state = State.DONE
var velocity = Vector2()
var path : PoolVector2Array


# Called when the node enters the scene tree for the first time.
func _ready():
	state = State.PATROL
	navigation2d = get_node(NAV_NODE)
	player = get_node(PLAYER_NODE)
	
	var path_parent = get_node(PATROL_NODE)
	patrol = path_parent.get_children()
	next_node = patrol[0]
	
	path = navigation2d.get_simple_path(position, next_node.get_position())
	
	# Enable the general process callback
	set_physics_process(true)


func _physics_process(delta):
	match state:
		State.PATROL:
			var near = position.distance_to(path[0]) <= CLOSE_ENOUGH
			if near:
				path.remove(0)
				if path.size() == 0:
					patrol.append(next_node)
					patrol.remove(0)
					next_node = patrol[0]
					path = navigation2d.get_simple_path(position, next_node.get_position())
		State.CHASE:
			next_node = player.position
		State.DONE:
			set_physics_process(false)
			return

	velocity = get_position().direction_to(path[0]) * WALK_SPEED
	move_and_slide(velocity)
