extends KinematicBody2D

var Utils : Object =  preload('res://scripts/Util.gd').new()
var animation_map = {
	Utils.Heading.None: "idle_right",
	Utils.Heading.East: "walk_right",
	Utils.Heading.SouthEast: "walk_right",
	Utils.Heading.South: "walk_right",
	Utils.Heading.SouthWest: "walk_left",
	Utils.Heading.West: "walk_left",
	Utils.Heading.NorthWest: "walk_left",
	Utils.Heading.North: "walk_left",
}

const WALK_SPEED : int = 200

var velocity = Vector2()

func _ready():
	# Allows checking of contacts
	pass

func get_input():
	velocity = Vector2()
	if Input.is_action_pressed("move_down"):
		velocity.y += 1
	if Input.is_action_pressed("move_up"):
		velocity.y -= 1
	if Input.is_action_pressed("move_left"):
		velocity.x -= 1
	if Input.is_action_pressed("move_right"):
		velocity.x += 1
	if Input.is_action_pressed("ui_cancel"):
		get_tree().quit()


func _physics_process(_delta):
	get_input()

	Utils.animate(velocity, $AnimationPlayer, animation_map)
	# We don't need to multiply velocity by delta because "move_and_slide" already takes delta time into account.
	# The second parameter of "move_and_slide" is the normal pointing up.
	# In the case of a 2D platformer, in Godot, upward is negative y, which translates to -1 as a normal.
	var _new_velocity = move_and_slide(velocity.normalized() * WALK_SPEED)
	
	for i in get_slide_count():
		var collision = get_slide_collision(i)
		if collision.collider.name == "Yang" or collision.collider.name == "Yin":
			game_over()

func game_over():
	get_node("/root/Node2D").set_scene("res://scenes/test/GameOver.tscn")
