extends "res://scripts/WalkStrategy.gd"

onready var straight_raycast = get_node("straight_raycast")
onready var left_raycast = get_node("left_raycast")
onready var right_raycast = get_node("right_raycast")

var rng = RandomNumberGenerator.new()

func _ready() -> void:
	._ready()
	
	rng.randomize()

func distance_until_collision(raycast: RayCast2D) -> float:
	if raycast.is_colliding():
		return (raycast.get_collision_point() - self.get_global_transform().get_origin()).length()
	else:
		return 1_000_000_000.0

func set_enemy_direction(delta: float):
	var left_distance = distance_until_collision(left_raycast)
	var right_distance = distance_until_collision(right_raycast)
	
	if straight_raycast.is_colliding():
		enemy.direction = enemy.direction.rotated(rng.randf_range(PI/4, 2*PI - PI/4)).normalized()
	
	if left_distance != right_distance:
		if left_distance > right_distance:
			enemy.direction = enemy.direction.rotated(-enemy.TURN_SPEED * delta).normalized()
		else:
			enemy.direction = enemy.direction.rotated(enemy.TURN_SPEED * delta).normalized()

func move(delta: float) -> void:
	set_enemy_direction(delta)
