extends Object

var QUADRANTS = 8

enum Heading {
	None = -1,
	East = 0,
	SouthEast = 2,
	South = 4,
	SouthWest = 6,
	West = 8,
	NorthWest = -6,
	North = -4,
	NorthEast = -2,
}


func get_heading(velocity: Vector2) -> int:
	return int(QUADRANTS * (velocity.angle() /  PI))


func animate(
	velocity: Vector2,
	player: AnimationPlayer,
	animations: Dictionary
) -> void:
	var new_heading = get_heading(velocity)
	var name = null

	if velocity == Vector2.ZERO:
		name = animations.get(Heading.None)
	else:
		name = animations.get(new_heading)

	if name != null:
		player.play(name)
