extends Node2D

# Declare member variables here. Examples:
# var a = 2
# var b = "text"
var interaction_area
export (NodePath) var player_path
var player
var sprite
var progress = 0

const ROTATION_SPEED = 10
const CLOSED_PROGRESS = 1

# Called when the node enters the scene tree for the first time.
func _ready():
	interaction_area = get_node("./InteractionArea")
	player = get_node(player_path)
	sprite = get_node("./Sprite")

signal closed



# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	if progress < CLOSED_PROGRESS && Input.is_action_pressed("interact") && interaction_area.overlaps_body(player):
		progress += delta
		sprite.set_rotation(progress * 10)
		if progress >= CLOSED_PROGRESS:
			emit_signal("closed")